// ClothControls.cpp : implementation file
//

#include "stdafx.h"
#include "glInteractive.h"
#include "ClothControls.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClothControls dialog


CClothControls::CClothControls(ParameterTable *pParams, CWnd* pParent /*=NULL*/)
	: CDialog(CClothControls::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClothControls)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pParams= pParams;
}


void CClothControls::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClothControls)
	DDX_Control(pDX, IDC_STATIC_VAL, m_StaticVal);
	DDX_Control(pDX, IDC_STATIC_MIN, m_StaticMin);
	DDX_Control(pDX, IDC_STATIC_MAX, m_StaticMax);
	DDX_Control(pDX, IDC_COMBO_BOX, m_Combo);
	DDX_Control(pDX, IDC_CLOTH_SLIDER, m_Slider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClothControls, CDialog)
	//{{AFX_MSG_MAP(CClothControls)
	ON_CBN_SELCHANGE(IDC_COMBO_BOX, OnSelchangeComboBox)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClothControls message handlers

BOOL CClothControls::OnInitDialog() 
{
	CDialog::OnInitDialog();

	Parameter **items;
	int count,i;

	count= m_pParams->Count();
	items= new Parameter*[count];
	count= m_pParams->Gather(items);
	for(i=0; i<count; i++)
		m_Combo.AddString(items[i]->name);
	delete [] items;
	m_Combo.SetCurSel(0);
	OnSelchangeComboBox();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClothControls::OnSelchangeComboBox() 
{
	int item,min,max;
	Parameter *currParam;
	char temp[20];

	item= m_Combo.GetCurSel();
	m_Combo.GetLBText(item,temp);
	currParam= m_pParams->Lookup(temp);
	sprintf(temp,"%1.2f",(float)currParam->max);
	m_StaticMax.SetWindowText(temp);
	sprintf(temp,"%1.2f",(float)currParam->min);
	m_StaticMin.SetWindowText(temp);
	sprintf(temp,"%1.2f",(float)currParam->val);
	m_StaticVal.SetWindowText(temp);
	min= m_Slider.GetRangeMin();
	max= m_Slider.GetRangeMax();
	m_Slider.SetPos(max-(int)((currParam->val-currParam->min)*(max-min)/(currParam->max-currParam->min)));
}

void CClothControls::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int pos,item,min,max;
	Parameter *currParam;
	char temp[20];

	item= m_Combo.GetCurSel();
	m_Combo.GetLBText(item,temp);
	currParam= m_pParams->Lookup(temp);
	min= m_Slider.GetRangeMin();
	max= m_Slider.GetRangeMax();
	pos= m_Slider.GetPos();
	currParam->val= currParam->min+((float)(pos-min)/(max-min))*(currParam->max-currParam->min);

	sprintf(temp,"%1.2f",(float)currParam->val);
	m_StaticVal.SetWindowText(temp);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CClothControls::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int pos,item,min,max;
	Parameter *currParam;
	char temp[20];

	item= m_Combo.GetCurSel();
	m_Combo.GetLBText(item,temp);
	currParam= m_pParams->Lookup(temp);
	min= m_Slider.GetRangeMin();
	max= m_Slider.GetRangeMax();
	pos= m_Slider.GetPos();
	currParam->val= currParam->min+((float)(max-pos)/(max-min))*(currParam->max-currParam->min);

	sprintf(temp,"%1.2f",(float)currParam->val);
	m_StaticVal.SetWindowText(temp);
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
