// glInteractiveView.h : interface of the CGlInteractiveView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLINTERACTIVEVIEW_H__EF0792FC_37F0_4E29_953E_6D39C7221266__INCLUDED_)
#define AFX_GLINTERACTIVEVIEW_H__EF0792FC_37F0_4E29_953E_6D39C7221266__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MOUSE_ZOOM	1
#define MOUSE_EXAM	2
#define MOUSE_PAN	4
#define MOUSE_SELECT_OBJECT	8
#define MOUSE_DRAG_OBJECT	16

#include "Handle.h"

class CGlInteractiveView : public CView
{
protected: // create from serialization only
	CGlInteractiveView();
	DECLARE_DYNCREATE(CGlInteractiveView)

// Attributes
public:
	CGlInteractiveDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGlInteractiveView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Resume();
	void Pause();
	virtual ~CGlInteractiveView();
	virtual void IncrementAnimation();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	UINT m_timerID;
	unsigned int m_viewMode;
	unsigned int m_mouseMode;
	CPoint m_mouseDown;
	double m_orthoScale,m_perspDist;
	double m_dOrientation[16];

	glObject *m_pSelection;
	Handle m_handle;
protected:					// stuff for OpenGL
	HGLRC m_hrc;			// OpenGL Rendering Context
	CDC *m_pDeviceContext;
	CPalette *m_pCPal;
	BOOL m_paletteMode;
	BOOL ReleaseRenderContext();
	BOOL GetRenderContext();
	void glDraw();
	glObject *glPick(int x,int y);

// Generated message map functions
protected:
	//{{AFX_MSG(CGlInteractiveView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnRunButton();
	afx_msg void OnUpdateRunButton(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in glInteractiveView.cpp
inline CGlInteractiveDoc* CGlInteractiveView::GetDocument()
   { return (CGlInteractiveDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLINTERACTIVEVIEW_H__EF0792FC_37F0_4E29_953E_6D39C7221266__INCLUDED_)
